/****************************************************************************\
*                                                                            *
*  FGIW2.CPP                                                                 *
*  FGIW2U.CPP                                                                *
*                                                                            *
*  This example shows how to play a flic file from an FGI library, using     *
*  either fgi_showflic() or the low-level fgi_flicxxx() routines.            *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGIW2U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(320,200);
   fg_vbopen(hvb);
   fg_vbcolors();

   hfgi = fgi_open("EXAMPLE.FGI");
   if (hfgi == 0)
   {
      Application->MessageBox("Unable to open FGI file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }
   fgi_flicopen("GLASS.FLI",context,hfgi);
   fg_flicplay(context,1,0);

   Application->OnActivate = OnActivate;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
   switch (Key)
   {
      case VK_F1:
         fgi_showflic("GLASS.FLI",2,0,hfgi);
         break;
      case VK_F2:
         fgi_flicskip(context,-1);
         while (fg_flicplay(context,1,0) > 0)
            fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
         fgi_flicskip(context,-1);
         while (fg_flicplay(context,1,0) > 0)
            fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
         break;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fgi_close(hfgi);
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
