/****************************************************************************\
*                                                                            *
*  FGIW6.CPP                                                                 *
*  FGIW6U.CPP                                                                *
*                                                                            *
*  Demonstrate how to load a Fastgraph/Fonts font file from an FGI library.  *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGIW6U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   int size;

   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(320,200);
   fg_vbopen(hvb);
   fg_vbcolors();

   hfgi = fgi_open("EXAMPLE.FGI");
   if (hfgi == 0)
   {
      Application->MessageBox("Unable to open FGI file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }
   size = fgi_filesize("BRODWY18.FGF",hfgi);
   buffer = new char[size];
   fgi_readnext(buffer,(int)size,hfgi);
   fgi_close(hfgi);

   fgf_define(buffer);
   fgf_justify(0,0);
   fg_setcolor(255);
   fg_fillpage();
   fg_setcolor(20);
   fg_move(160,100);
   fgf_print("BROADWAY FONT",13);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete[] buffer;
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
